#include <wx/app.h>
#include <wx/event.h>
#include <wx/string.h>
#include <wx/thread.h>

#include "Thread.h"

DEFINE_EVENT_TYPE(E_MyEvent)


BEGIN_EVENT_TABLE(SS_SocketHandler, wxEvtHandler)
EVT_SOCKET(My_SOCKET_ID, SS_SocketHandler::OnSocketEvent)
EVT_SOCKET(My_SERVER_ID, SS_SocketHandler::OnServerEvent)
END_EVENT_TABLE()

// ================================================================


SS_SocketHandler::SS_SocketHandler(SS_Server * Server) : wxEvtHandler()
{
  Parent=Server;
}



SS_SocketHandler::~SS_SocketHandler()
{

}

//============================================================

void SS_SocketHandler::OnSocketEvent(wxSocketEvent& event)
{
  size_t nread = 0;
  char Buffer[500];
  this->Parent->SendThreadMessage(_("SOCKET EVENT !!!!"),ThreadDebug);

  //wxSocketBase * sock = (wxSocketBase*)event.GetClientData();
  wxSocketBase *sock = event.GetSocket();

  int a=event.GetSocketEvent();
  this->Parent->SendThreadMessage((_("Received event code ")+IntTowxT(a)),ThreadDebug);

if(sock)
{
  if ( event.GetSocketEvent() == wxSOCKET_INPUT ) {
    sock->SetNotify(wxSOCKET_LOST_FLAG);
    wxString data;// = sock->Receive();

    this->Parent->SendThreadMessage(_("SK wxSOCKET_INPUT !!!!!"),ThreadDebug);

    sock->Read(&Buffer, 300);
    nread = sock->LastCount();
    this->Parent->SendThreadMessage((_("Buffer len is: ")+IntTowxT(nread)),ThreadDebug);
    data=Str2AnsiHex(Buffer,nread);
    this->Parent->SendThreadMessage((_("Buffer  is: ")+data),ThreadDebug);
    sock->SetNotify(wxID_ANY);
  }
  else if ( event.GetSocketEvent() == wxSOCKET_LOST )
  {
    this->Parent->SendThreadMessage(_("SK wxSOCKET_LOST !!!!!"),ThreadDebug);
  }
  else if ( event.GetSocketEvent() == wxSOCKET_CONNECTION )
  {
    this->Parent->SendThreadMessage(_("SK wxSOCKET_CONNECTION !!!!!"),ThreadDebug);
  }
  else if ( event.GetSocketEvent() == wxSOCKET_OUTPUT )
  {
    this->Parent->SendThreadMessage(_("SK wxSOCKET_OUTPUT !!!!!"),ThreadDebug); // connesso al servr...puoi inviare dati se serve
  }
  else this->Parent->SendThreadMessage(_("UNKNOWED SOCKET EVENT"),ThreadDebug);
}
}

//============================================================

void SS_SocketHandler::OnServerEvent(wxSocketEvent& event)
{
//wxSOCKET_INPUT = 0   wxSOCKET_OUTPUT = 1   wxSOCKET_CONNECTION = 2   wxSOCKET_LOST = 3
  wxSocketBase *sock = event.GetSocket();
  int a=event.GetSocketEvent();
  this->Parent->SendThreadMessage((_("SERVER EVENT: Received event code ")+IntTowxT(a)),ThreadDebug);

if(sock)
{
  if (event.GetSocketEvent() == wxSOCKET_CONNECTION )
  {
    wxSocketBase * tempsok;
    tempsok=this->Parent->s_server->Accept(false);
    if(tempsok) // new socketbase for client communication
    {
      Parent->SendThreadMessage(_("...accepting connection (SK wxSOCKET_CONNECTION)"),ThreadDebug);
      //tempsok->SetClientData( (void*)this );
      tempsok->SetEventHandler(*(this->Parent->SEH), My_SOCKET_ID);
      tempsok->SetNotify(wxID_ANY); // wxSOCKET_INPUT_FLAG | wxSOCKET_LOST_FLAG | wxSOCKET_CONNECTION_FLAG
      tempsok->Notify(true);
    }
  }
  else this->Parent->SendThreadMessage(_("UN-INTERCEPTED SERVER EVENT"),ThreadDebug);
}
}


//============================================================

SS_Server::~SS_Server()
{
  delete SEH;//if(SEH) delete SEH;
}

//============================================================

SS_Server::SS_Server(wxEvtHandler *ev): wxThread(wxTHREAD_JOINABLE)
{
  s_TCP_port=3000; // la stessa usata nel client socket negli esempi delle wxwidgets!
  s_server=NULL;
  EH=ev;
  SEH=NULL;
}

//============================================================
void* SS_Server::Entry()
{
if(Start_TCP_Server()<0)
{
  SendThreadMessage(_("ERROR STARTING SOCKET THREAD"),ThreadDebug);
  return(NULL);
}

while(1)
{
    if (TestDestroy())
    {
      delete s_server;
      break;
    }
    wxThread::Sleep(500); // attende 500 msec
}
}

//============================================================

int SS_Server::Start_TCP_Server()
{
  wxIPV4address Addr;
  Addr.Service(s_TCP_port);
  if(s_server) return(-1); // only 1 instance
  s_server = new wxSocketServer(Addr);
  if(!s_server) return(-2);
  if (! s_server->IsOk()) return(-3); // We use Ok() here to see if the server is really listening
  SEH=new SS_SocketHandler(this);

  if(!SEH) SendThreadMessage(_("error creating SocketEventHandler"),ThreadDebug);
  else
  {
    s_server->SetClientData( (void*)this );
    s_server->SetEventHandler(*SEH, My_SERVER_ID);
    s_server->SetNotify(wxSOCKET_INPUT_FLAG | wxSOCKET_LOST_FLAG | wxSOCKET_CONNECTION_FLAG);
    s_server->Notify(true);
    SendThreadMessage(_("server inizialized"),ThreadDebug);
  }

  return(1);
}

//============================================================

// questa l'abbiamo vista nelle scorse puntate
void SS_Server::SendThreadMessage(wxString str,int type)
{
    if(EH)
    {
      C_MyEvent event(E_MyEvent,type);
      event.SetText(str);
      wxPostEvent( EH, event );
    }
}

// le due funzioni sottostanti servono solamente a stampare il contenuto di una stringa
// con i valori esadecimali dei singoli bytes per permettere il debug di buffer binari

wxString Str2AnsiHex(char * cm,unsigned short len)
{
	wxString AS=_("");
  for (unsigned short a=0;a<len;a++)
  {
    AS=AS+(Char2AnsiHex(cm[a]));
    AS=AS+wxT(" ");
  }
	return(AS);
}

wxString Char2AnsiHex(char cr)
{
	wxString ST;
	ST.Printf(wxT("%2.2X"),(unsigned char)cr);
	return(ST);
}
